/*
**		Copyright (C) Roman Ukhov 2000
**		e-mail: r_ukhov@yahoo.com
**		http://rukhov.newmail.ru
*/

#include "http_server.hpp"

const char szCopyright[]="Copyright (C) Roman Ukhov 2000";
char szAppName[128];

std::ostream& srv_out=std::cout;
std::ostream& srv_err=std::cerr;

process::critical_section log_cs;
process::critical_section err_cs;

#define HTTP_SERVER_VERSION_MAJOR	1
#define HTTP_SERVER_VERSION_MINOR	0

void server_globals_init()
{
	wsprintf(szAppName, "HTTP Server/%u.%u", 
		HTTP_SERVER_VERSION_MAJOR,
		HTTP_SERVER_VERSION_MINOR);
}

void write_to_cout_log(const std::string &str)
{
	process::auto_lock lock(log_cs);

	srv_out<<str<<std::endl;
}

void write_to_cerr_log(const std::string &str)
{
	process::critical_section log_cs;
	process::auto_lock lock(err_cs);

	srv_err<<str<<std::endl;
}