/*
**		Copyright (C) Roman Ukhov 2000
**		e-mail: r_ukhov@yahoo.com
**		http://rukhov.newmail.ru
*/

#include "http_server.hpp"
#include "http_date.hpp"
#include <sstream>

static const std::string weekdays[]={
	"Sun",
	"Mon",
	"Tue",
	"Wed",
	"Thu",
	"Fri",
	"Sat"
};

static const std::string months[]={
	"Jan",
	"Feb",
	"Mar",
	"Apr",
	"May",
	"Jun",
	"Jul",
	"Aug",
	"Sep",
	"Oct",
	"Nov",
	"Dec"
};


http_date::http_date()
{
}

http_date::http_date(const std::string& str)
{
	http_date& x=from_string(str);

	wYear=x.wYear;
	wMonth=x.wMonth;
	wDayOfWeek=x.wDayOfWeek;
	wDay=x.wDay;
	wHour=x.wHour;
	wMinute=x.wMinute;
	wSecond=x.wSecond;
	wMilliseconds=0;
}

http_date::~http_date()
{
}



http_date 
http_date::from_string(const std::string& str)
{
	http_date date;
	std::string buff;
	std::istringstream strbuff(str);

	if(strbuff.eof() == false){
		strbuff>>buff;
		buff.erase(3);
		for(int i=0; i<sizeof(weekdays)/sizeof(std::string); i++){
			if(buff.find_first_not_of(weekdays[i])==std::string::npos){
				date.wDayOfWeek=i;
				break;
			}
		}
		if(strbuff.eof() == false){
			strbuff>>buff;
			date.wDay=atol(buff.c_str());
			if(strbuff.eof() == false){
				strbuff>>buff;
				for(int i=0; i<sizeof(months)/sizeof(std::string); i++){
					if(buff==months[i]){
						date.wMonth=i+1;
						break;
					}
				}
				if(strbuff.eof() == false){
					strbuff>>buff;
					date.wYear=atol(buff.c_str());
					if(strbuff.eof() == false){
						strbuff>>buff;
						sscanf( 
							buff.c_str(), 
							"%02u:%02u:%02u", 
							&date.wHour,
							&date.wMinute,
							&date.wSecond);
						date.wMilliseconds=0;
					}
				}
			}
		}
	}
	

	return date;
}

http_date::operator const std::string () const
{
	char szTmp[1024];

	if(is_valid()){
		sprintf(szTmp, "%s, %u %s %u %02u:%02u:%02u GMT",
			weekdays[wDayOfWeek].c_str(),
			wDay,
			months[wMonth-1].c_str(),
			wYear,
			wHour,
			wMinute,
			wSecond);
	
		return std::string(szTmp);
	}else{
		return "Invalid Date";
	}
}
