/*
**		Copyright (C) Roman Ukhov 2000
**		e-mail: r_ukhov@yahoo.com
**		http://rukhov.newmail.ru
*/

#if !defined(_HTTP_DATE_HPP_INCLUDED_)
#define _HTTP_DATE_HPP_INCLUDED_

class http_date : public SYSTEMTIME
{
public:
	http_date();
	http_date(const SYSTEMTIME& time)
	{
		wYear=time.wYear;
		wMonth=time.wMonth;
		wDayOfWeek=time.wDayOfWeek;
		wDay=time.wDay;
		wHour=time.wHour;
		wMinute=time.wMinute;
		wSecond=time.wSecond;
		wMilliseconds=0;
	}

	http_date& operator = (const http_date& x){
		wYear=x.wYear;
		wMonth=x.wMonth;
		wDayOfWeek=x.wDayOfWeek;
		wDay=x.wDay;
		wHour=x.wHour;
		wMinute=x.wMinute;
		wSecond=x.wSecond;
		wMilliseconds=0;

		return *this;
	}

	bool operator == (const http_date& x){
		return (wYear==x.wYear &&
			wMonth==x.wMonth &&
			wDayOfWeek==x.wDayOfWeek &&
			wDay==x.wDay &&
			wHour==x.wHour &&
			wMinute==x.wMinute &&
			wSecond==x.wSecond);
	}

	bool operator != (const http_date& x){
		return (wYear!=x.wYear ||
			wMonth!=x.wMonth ||
			wDayOfWeek!=x.wDayOfWeek ||
			wDay!=x.wDay ||
			wHour!=x.wHour ||
			wMinute!=x.wMinute ||
			wSecond!=x.wSecond);
	}

	http_date(const std::string& str);
	~http_date();

	operator const std::string () const;

	bool is_valid() const{
		return (wYear < 3000 &&
			wMonth < 13 &&
			wMonth > 0 &&
			wDayOfWeek < 7 &&
			wDay < 31 &&
			wHour < 24 &&
			wMinute < 60 &&
			wSecond < 60);
	}

	static http_date from_string(const std::string& str);
};

#endif //_HTTP_DATE_HPP_INCLUDED_
