/*
**		Copyright (C) Roman Ukhov 2000
**		e-mail: r_ukhov@yahoo.com
**		http://rukhov.newmail.ru
*/

#include "http_server.hpp"
#include "ip_addr.hpp"

namespace network
{
	ip_addr::ip_addr(
			unsigned char b1, 
			unsigned char b2, 
			unsigned char b3, 
			unsigned char b4, 
			unsigned short port)
	{
		sockaddr_in& addr=*((sockaddr_in*)this);
		addr.sin_family=AF_INET;
		addr.sin_addr.S_un.S_un_b.s_b1=b1;
		addr.sin_addr.S_un.S_un_b.s_b2=b2;
		addr.sin_addr.S_un.S_un_b.s_b3=b3;
		addr.sin_addr.S_un.S_un_b.s_b4=b4;
		addr.sin_port=htons(port);
	}

	ip_addr::ip_addr(const std::string& _str_addr)
	{
		std::string b[5];
		int bn=0;
		
		for(int i=0; i<_str_addr.size(); i++){
			if(_str_addr[i]=='.' || _str_addr[i]==':'){
				bn++;
				if(bn>4)break;
			}else{
				b[bn]+=_str_addr[i];
			}
		}

		sockaddr_in& addr=*((sockaddr_in*)this);
		addr.sin_family=AF_INET;
		addr.sin_addr.S_un.S_un_b.s_b1=atol(b[0].c_str());
		addr.sin_addr.S_un.S_un_b.s_b2=atol(b[1].c_str());
		addr.sin_addr.S_un.S_un_b.s_b3=atol(b[2].c_str());
		addr.sin_addr.S_un.S_un_b.s_b4=atol(b[3].c_str());
		addr.sin_port=htons((u_short)atol(b[4].c_str()));
	}

	const std::string 
		ip_addr::to_string() const
	{
		char szTmp[64];
		sockaddr_in& addr=*((sockaddr_in*)this);
		
		wsprintf(szTmp, "%u.%u.%u.%u:%u", 
			addr.sin_addr.S_un.S_un_b.s_b1,
			addr.sin_addr.S_un.S_un_b.s_b2,
			addr.sin_addr.S_un.S_un_b.s_b3,
			addr.sin_addr.S_un.S_un_b.s_b4,
			ntohs(addr.sin_port));

		return szTmp;
	}
}