/*
**		Copyright (C) Roman Ukhov 2000
**		e-mail: r_ukhov@yahoo.com
**		http://rukhov.newmail.ru
*/

#if !defined(_LIETEN_SOCKET_H_INCLUDED_)
#define _LIETEN_SOCKET_H_INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <set>
#include <queue>

class listen_socket : public network::async_socket  
{
public:
	listen_socket(
		const std::string& _ip = "0.0.0.0:80",
		const std::string& _root_dir = ".",
		const std::string& _index_file_name = std::string(),
		bool _allow_directory_browsing = false,
		size_t max_conn = 100,
		unsigned long timeout = 60);
	virtual ~listen_socket();

	bool start(UINT port = 80, char* addr = 0, const std::string& _host_name = "");
	void stop();
	void set_max_conn(size_t max_conn = 100);
	void set_conn_timeout(unsigned long timeout = 60);
	void set_index_file_name(const std::string& index);
protected:
	virtual void on_accept(int err);
private:
	typedef std::set<const request_socket*> busy_request_t;
	typedef busy_request_t::iterator busy_request_iterator_t;
	typedef std::queue<accepted_socket> waiting_rquest_t;
	process::critical_section	object_cs;
	size_t max_concurent_connections;
	unsigned long connection_timeout;
	std::string root_dir;
	std::string host_name;
	std::string index_file_name;
	bool allow_directory_browsing;


	busy_request_t busy_set;
	waiting_rquest_t waitong_requests;

	process::thread free_tread;
	HANDLE hMessageQueueCreatedEvent;
	static int static_free_thread_func(void*);
	int free_thread_func();

	static void static_request_call_back_fn(request_socket::call_back_reason, const request_socket*, const void*);
	void request_call_back_fn(request_socket::call_back_reason, const request_socket*);
};

#endif //_LIETEN_SOCKET_H_INCLUDED_
