/*
**		Copyright (C) Roman Ukhov 2000
**		e-mail: r_ukhov@yahoo.com
**		http://rukhov.newmail.ru
*/

#include "http_server.hpp"
#include "prog_opt.hpp"

using namespace std;

void 
prog_options::print_usage()
{
	for(int i=0; i<opt_count; i++){
		cout.setf(ios::left, ios::adjustfield);
		cout<<"-";
		cout.width(max_opt_len);
		cout
			<<opt_array[i].name;
		if(opt_array[i].coment.size()>0){
			cout<<'\t'<<opt_array[i].coment;
			
			if(opt_array[i].default_val.size()>0){
				cout<<" (default: "<<opt_array[i].default_val<<')';
			}
		}
		cout<<endl;
	}
}

void 
prog_options::parse_cmd_line(int argc, char* argv[])
{
	int opt_idx=-1;
	if(argc<1)return;

	for(int i=1; i<argc; i++){
		if(opt_idx!=-1){
			opt_array[opt_idx].value=argv[i];
			opt_idx=-1;
		}else{
			if(argv[i][0]=='-'){
				for(int j=0; j<opt_count; j++){
					if(opt_array[j].name.compare(&(argv[i][1]))==0){
						opt_idx=j;
					}
				}
			}
		}
	}
}

void 
prog_options::print_values()
{
	for(int i=0; i<opt_count; i++){
		cout<<opt_array[i].coment;
		cout<<": "<<opt_array[i].value;
		cout<<endl;
	}
}