/*
**		Copyright (C) Roman Ukhov 2000
**		e-mail: r_ukhov@yahoo.com
**		http://rukhov.newmail.ru
*/

#if !defined(_PROG_OPT_HPP_INCLUDED_)
#define _PROG_OPT_HPP_INCLUDED_

#include <iostream>

class prog_options;
class option
{
friend class prog_options;
public:
	option(
		const std::string& _name,
		const std::string& _default_val = "",
		const std::string& _coment = ""):
	name(_name),
	coment(_coment),
	default_val(_default_val),
	value(_default_val){
	}

	option(const option& x):
	name(x.name),
	coment(x.coment),
	default_val(x.default_val){
	}

	~option(){}

	const std::string& get_value() const {
		return value;
	}
	void set_value(const std::string& str){
		value=str;
	}
	const std::string& get_default() const {
		return default_val;
	}
protected:
private:
	const std::string name;
	const std::string coment;
	const std::string default_val;
	std::string value;
};

class prog_options
{
public:
	prog_options(
		option _opt_array[], 
		unsigned long _opt_count):
	opt_array(_opt_array),
	opt_count(_opt_count),
	max_opt_len(0){
		for(int i=0; i<opt_count; i++){
			if(opt_array[i].name.size()>max_opt_len)
				max_opt_len=opt_array[i].name.size();
		}
	}

	~prog_options(){}

	void parse_cmd_line(int argc, char* argv[]);
	void print_usage();
	void print_values();
protected:
private:
	option* opt_array;
	const unsigned long opt_count;
	long max_opt_len;
};

#endif //_PROG_OPT_HPP_INCLUDED_
