/*
**		Copyright (C) Roman Ukhov 2000
**		e-mail: r_ukhov@yahoo.com
**		http://rukhov.newmail.ru
*/

#if !defined(_REQUEST_H_INCLUDED_)
#define _REQUEST_H_INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "http_date.hpp"

class request  
{
public:
	enum request_type {
		unknown = 0,
		timeout,
		head,
		get, 
		get_if_modified
	};
	request();
	virtual ~request();
	
	request_type type;
	std::string requested_target;
	std::string host;
	unsigned short http_version_minor, http_version_major;
	unsigned long beg_pos;
	unsigned long end_pos;
	unsigned long instance_length;
	http_date remote_file_date;
	bool Entity_Too_Large;
	bool Request_URI_Too_Long;
	bool keep_alive;

	unsigned long request_processed;

	void clear_request();
protected:
	bool interpret_request(const char* buff, size_t len);
	bool interpret_line(char* line, int line_size);
	bool request_timeout();
private:
	static bool get_line(char* *p_buff, 
		int* len, char* *p_line, int* line_size);
};

#endif //_REQUEST_H_INCLUDED_
