/*
**		Copyright (C) Roman Ukhov 2000
**		e-mail: r_ukhov@yahoo.com
**		http://rukhov.newmail.ru
*/

#if !defined(_REQUEST_SOCKET_H_INCLUDED_)
#define _REQUEST_SOCKET_H_INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "request.h"
#include "respond.h"

class request_socket : public network::async_socket, request, respond
{
public:
	enum call_back_reason{
		destroyed
	};
	typedef void (*call_back_fn)(call_back_reason, const request_socket*, const void*);
	request_socket(
		const std::string& _host_name,
		const std::string& _root_dir = ".",
		const std::string _index_file_name = std::string(),
		bool _allow_directory_browsing = true,
		unsigned long _timeout = 60,
		const call_back_fn _call_back = 0,
		const void* _call_back_param = 0);
	virtual ~request_socket();

	static unsigned long get_conn_count();
	static void wait_for_all_close();
protected:
	virtual void on_attach();
	virtual void on_close(int err);
	virtual void on_read(int err);
	virtual void on_write(int err);
	virtual void on_read_complete(DWORD err, DWORD len);
	virtual void on_write_complete(DWORD err, DWORD len);
	virtual void on_clear();
	virtual void on_timeout();

private:
	char readBuff[0x1000];

	unsigned long cb_sended;
	unsigned long cb_readed;
private:
	static void add_ref(request_socket* p_This);
	static void release(request_socket* p_This);
	static process::critical_section class_cs;
	const call_back_fn call_back;
	const void* call_back_param;
};

#endif //_REQUEST_SOCKET_H_INCLUDED_

