/*
**		Copyright (C) Roman Ukhov 2000
**		e-mail: r_ukhov@yahoo.com
**		http://rukhov.newmail.ru
*/

#if !defined(_RESPOND_H_INCLUDED_)
#define _RESPOND_H_INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#define RESPOND_BUFF_SIZE 0x1000

typedef enum {
	unknown = 0,
	html = 1,
	pdf = 2,
	gif = 3,
	msword = 4,
	rar = 5,
	txt = 6,
	jpeg = 7,
	zip = 8,
	wri = 9
} cont_types_t;


class respond  
{
public:
	respond(
		const std::string _host_name,
		const std::string _root_dir,
		const std::string _index_file_name = std::string(),
		bool _allow_directory_browsing = true);
	virtual ~respond();


	void clear();
	bool make_respond(request& rqu);
	void move_pointers(int how_mach);
	bool get_buffer_for_send(char* *pp_buff, int* p_len);
	std::string respond_str;
	cont_types_t content_type;
	HANDLE hFile;
	UINT err_code;
	SYSTEMTIME file_time;
	DWORD file_size;
	DWORD start_from;
	DWORD file_pos;
	DWORD file_end_pos;
	DWORD cb_buffered;
	DWORD buff_pos;


	std::string log_str;
	std::string stuff_str;

	void make_date_time_str(const SYSTEMTIME* time, std::string* str);
	bool get_file_time(HANDLE h_File, SYSTEMTIME* time);
private:
	bool b_have_body;
	const bool allow_directory_browsing;
	const std::string index_file_name;
	std::string host_name;
	std::string add_to_header;

	char buffer[RESPOND_BUFF_SIZE];
	bool make_temp_file();
	bool write_stuff();
	void what_content_type(const request& rqu);
	void content_type_to_str(const cont_types_t type, std::string* str);
	void add_header_to_stuff(
		const std::string& head,
		const std::string& title);
	void close_stuff();
	bool find_file(std::string name, bool* b_is_directory);
	bool open_file(const request& rqu, char* szHttpErr, bool request_is_dir);
	bool not_found_stuff(const request& rqu, char* szHttpErr);
	bool ditectory_stuff(const request& rqu, char* szHttpErr);
	bool redirect_stuff(const request& rqu, char* szHttpErr);
	bool forbidden_stuff(const request& rqu, char* szHttpErr, bool reqwest_is_dir);
	bool not_implemented_stuff(const request& rqu, char* szHttpErr);
	bool not_metod_allowed_stuff(const request& rqu, char* szHttpErr);
	bool request_timeout_stuff(const request& rqu, char* szHttpErr);
	bool wrong_range_stuff(const request& rqu, char* szHttpErr, unsigned long start, unsigned long stop, unsigned long size);
	bool uri_too_long(const request& rqu, char* szHttpErr);
	bool not_modified_stuff(const request& rqu, char* szHttpErr);
	const std::string root_dir;
	std::string requested_file;
	std::string requested_path;
	bool parse_url(std::string& requested_target, bool* is_dir);
	std::string str_date;
};

#endif //_RESPOND_H_INCLUDED_
