/*
**		Copyright (C) Roman Ukhov 2000
**		e-mail: r_ukhov@yahoo.com
**		http://rukhov.newmail.ru
*/

#include "http_server.hpp"
#include <process.h>
#include "thread.hpp"

namespace process
{
	
	thread::thread(bool _auto_delete/* = false*/)
		:
	auto_delete(_auto_delete),
	hThread(NULL),
	ThreadID(0),
	ret_val(0),
	param(0),
	start_addres(0)
	{
	}
	
	thread::~thread(){
		if(hThread!=NULL)
			CloseHandle(hThread);
	}
	
	bool 
		thread::create(thread_func func, void* _param, bool suspended){

		start_addres=func;
		param=_param;

		hThread = (HANDLE) _beginthreadex(
			NULL, 
			0, 
			static_start_func,
			this, 
			suspended == true ? CREATE_SUSPENDED : 0, 
			(unsigned int*)&ThreadID);

		return true;
	}

	unsigned __stdcall 
		thread::static_start_func(void* pThis){

		unsigned ret;

		if(reinterpret_cast<thread*>(pThis)->start_addres==0){
			unsigned ret=reinterpret_cast<thread*>(pThis)->ret_val=
				reinterpret_cast<thread*>(pThis)->thread_function();
		}else{
			ret = reinterpret_cast<thread*>(pThis)->start_addres(reinterpret_cast<thread*>(pThis)->param);
		}

		if(reinterpret_cast<thread*>(pThis)->auto_delete == true){
			delete reinterpret_cast<thread*>(pThis);
		}

		return ret;
	}

	int 
		thread::thread_function(){

		return 0;
	}

	bool 
		thread::wait_for_end(unsigned long tiomeout){

		if( hThread == NULL )return true;

		if(WaitForSingleObject(
			hThread, 
			tiomeout == 0 ? INFINITE : tiomeout	) == WAIT_TIMEOUT){
			return false;
		}

		return true;
	}

	void 
		thread::resume() const{

		ResumeThread(hThread);
	}
	
	void 
		thread::suspend() const{
		SuspendThread(hThread);
	}

	bool 
		thread::set_priority(int priority) const{

		if(SetThreadPriority(
			hThread,
			priority) == TRUE){
			return true;
		}else{
			return false;
		}
	}

	bool 
		thread::post_message(const UINT msg, const WPARAM wParam, const LPARAM lParam) const
	{
		if(PostThreadMessage( 
			ThreadID, 
			msg, 
			wParam, 
			lParam)==TRUE){
			return true;
		}else
			return false;
	}
}
