/*
**		Copyright (C) Roman Ukhov 2000
**		e-mail: r_ukhov@yahoo.com
**		http://rukhov.newmail.ru
*/

#if !defined(_THREAD_HPP_INCLUDE_)
#define _THREAD_HPP_INCLUDE_

#include <windows.h>

namespace process
{
	class thread
	{
	public:
		typedef int (*thread_func)(void*);
		thread(bool _auto_delete = false);
		~thread();

		bool create(thread_func start_addr = 0, 
			void* _param = 0, bool suspended = false);

		bool wait_for_end(unsigned long tiomeout = 0);
		void resume() const;
		void suspend() const;
		bool set_priority(int priority) const;
		bool post_message(const UINT msg, 
			const WPARAM wParam = 0, 
			const LPARAM lParam = 0) const;

	protected:
		virtual int thread_function();
	private:
		thread_func start_addres;
		bool auto_delete;
		int ret_val;
		void* param;
		HANDLE hThread;
		unsigned long ThreadID;
		static unsigned __stdcall static_start_func(void *);
	};
}

#endif //_THREAD_HPP_INCLUDE_